// MODULE: CheckBoxTest.java
// AUTEUR: IFT1170
// OBJET: montrer une checkbox
//        introduire le GridLayout

import java.awt.*;
import java.awt.event.*;

public class CheckBoxTest extends FenetreFermante implements ItemListener {

  // quelques references et donnees primitives
  private Checkbox bleue,rouge,vert;
  private Checkbox jours[] = {
    new Checkbox("lundi"),
    new Checkbox("mardi"),
    new Checkbox("mercredi"),
    new Checkbox("jeudi"),
    new Checkbox("vendredi"),
    new Checkbox("samedi"),
    new Checkbox("dimanche")
  };
  boolean bleueSelectionnee, vertSelectionnee, rougeSelectionnee;

  // le constructeur
  public CheckBoxTest(int l,int h, String titre) {
     super(l,h);
     setTitle(titre);

     bleueSelectionnee=vertSelectionnee=rougeSelectionnee=false; // inutile mais plus propre

     setLayout(new FlowLayout());
     Panel panelCouleur = new Panel();

     bleue = new Checkbox("bleu");
     rouge = new Checkbox("rouge");
     vert = new Checkbox("vert");
     panelCouleur.add(bleue);
     panelCouleur.add(rouge);
     panelCouleur.add(vert);
     bleue.addItemListener(this);
     vert.addItemListener(this);
     rouge.addItemListener(this);

     Panel panelJours= new Panel(new GridLayout(7,1));
     for (int i=0; i<jours.length; i++) {
         jours[i].addItemListener(this);
         panelJours.add(jours[i]);
     }
          
     add(panelJours);
     add(panelCouleur);
     show();

  }

  // la seule methode de l'interface ItemListener
  public void itemStateChanged(ItemEvent e) {
    if (e.getSource() == bleue) {
       bleueSelectionnee = ! bleueSelectionnee;
       setBackground(getCouleur());
    } else
    if (e.getSource() == rouge) {
        rougeSelectionnee = ! rougeSelectionnee;
        setBackground(getCouleur());
    } else
    if (e.getSource() == vert) {
          vertSelectionnee = ! vertSelectionnee;
          setBackground(getCouleur());
    } else { // il s'agit d'un jour
      for (int i=0; i< jours.length; i++)
        if (e.getSource() == jours[i]) {
          System.out.println(jours[i].getLabel());
          break;
        }
    }
  }

  public static void main(String [] args) {
    new CheckBoxTest(330,230,"CheckBox");
  }

  // gestion du melange des couleurs
  private Color getCouleur() {
    if (bleueSelectionnee && rougeSelectionnee && vertSelectionnee) return Color.gray;
    if (bleueSelectionnee && rougeSelectionnee) return Color.magenta;
    if (bleueSelectionnee && vertSelectionnee) return Color.orange;
    if (bleueSelectionnee) return Color.blue;

    // no blue

    if (rougeSelectionnee && vertSelectionnee) return Color.yellow;
    if (rougeSelectionnee) return Color.red;

    if (vertSelectionnee) return Color.green;
    return Color.white;

  }

}
