// MODULE:  GuiList.java
// AUTEUR: IFT1170
// OBJET: montrer les choix et les listes

import java.awt.*;
import java.awt.event.*;

public class GuiList extends FenetreFermante
implements ItemListener, ActionListener {

  private String depart[] = { "Marseille","Stockholm", "Montral"};
  private String arrivee[] = { "Paris","Umea", "Qubec"};
  private String noms[] = {"Tremblay","Simard","Plamondon","Ouelet","Thibaut","Bedard"};
  private List liste;
  private Choice fromChoice,toChoice;
  private Label fromLabel, toLabel, nomLabel;

  // le constructeur
  public GuiList(int l,int h, String titre) {
     super(l,h);
     setTitle(titre);

     setLayout(new FlowLayout());

     Panel p1 = new Panel();
     Panel p2 = new Panel();

     fromLabel = new Label("de:");
     toLabel = new Label("vers:");
     fromChoice = new Choice();
     toChoice = new Choice();

     for (int i=0; i<depart.length; i++) fromChoice.add(depart[i]);
     for (int i=0; i<arrivee.length; i++) toChoice.add(arrivee[i]);

     p1.add(fromLabel); p1.add(fromChoice);
     p1.add(toLabel); p1.add(toChoice);

     liste = new List (5,true);
     nomLabel = new Label("Selectionnez des noms:");

     for (int i=0; i<noms.length; i++) liste.add(noms[i]);

     p2.add(nomLabel);
     p2.add(liste);

     // ajout des panels
     add(p1);
     add(p2);

     // enregistrement des gestionnaires d'evenements
     fromChoice.addItemListener(this);
     toChoice.addItemListener(this);
     liste.addActionListener(this);
     show();
  }

  // la seule methode de l'interface ItemListener
  public void itemStateChanged(ItemEvent e) {
    if (e.getSource() == fromChoice)
      System.out.println("Depart de " + e.getItem());
    else
      System.out.println("Arrivee de " + e.getItem());
  }

  // la seule methode de l'interface ActionListener
  // si un seul choix getSelectedItem()
  public void actionPerformed(ActionEvent e) {
    if (e.getSource() == liste) {
      String itemsSelectionnes [] =
         liste.getSelectedItems();
      System.out.print("actionPerformed ");
      for (int i=0; i<itemsSelectionnes.length; i++)
        System.out.print(" " + itemsSelectionnes[i]);
      System.out.println("");
    }
  }

  public static void main(String [] args) {
    new GuiList(330,230,"List et Choice");
  }
}