// MODULE:  GuiList.java
// AUTEURS: Langlais (AWT) + Lokbani (Swing)
// OBJET: montrer les choix et les listes

/*
  plus de choice ni besoin de list
  dans swing: ComboBox
              JList

  Pas d'coute du type vnement (Action, Item) sur les listes.
  Nous disposons que de ...

  import javax.swing.event.*; // ListSelectionListener

  public interface ListSelectionListener {
    void valueChanged(ListSelectionEvent e);
  }
  
  attention aux diffrents clics d'entres sorties au moment
  lors de l'accs  la liste => une astuce i-jointe

  le double clic n'est pas gr,  prvoir lors du codage ...

  il n'y a pas de scrollpane par dfaut dans une liste!! Il
  faut le prvoir pour toute liste ...
  inclure le scrollpane dans la liste mais pas l'inverse!!!
  puis inclure le scrollpane dans le getContentPane.

  ComboBox

  ne pas oublier de permettre l'edit dessus sinon nous ne verrons
  pas les changements!

*/

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*; // ListSelectionListener

class FenetreFermante extends JFrame {

  public FenetreFermante (int largeur,int hauteur) {
    setTitle("Quatrieme version:" + getClass().getName());
    setSize(largeur,hauteur);
    addWindowListener(new WindowAdapter () {
        public void windowClosing (WindowEvent e) {System.exit(0);}
      }
    );
  }
}

public class GuiList extends FenetreFermante implements ItemListener, ListSelectionListener {

  private String depart[] = { "Marseille","Stockholm", "Montral"};
  private String arrivee[] = { "Paris","Umea", "Qubec"};
  private String noms[] = {"Tremblay","Simard","Plamondon","Ouelet","Thibaut","Bedard","Martin","Marie","Elisabeth","Sophie"};
  private JList liste;
  private JComboBox fromChoice,toChoice;
  private JLabel fromLabel, toLabel, nomLabel;

  // le constructeur
  public GuiList(int l,int h, String titre) {
     super(l,h);
     setTitle(titre);

     Container c = getContentPane();

     c.setLayout(new FlowLayout());

     JPanel p1 = new JPanel();
     JPanel p2 = new JPanel();

     fromLabel = new JLabel("de:");
     toLabel = new JLabel("vers:");
     fromChoice = new JComboBox(depart);
     toChoice = new JComboBox(arrivee);
     fromChoice.setEditable(true);
     toChoice.setEditable(true);


     p1.add(fromLabel);
     p1.add(fromChoice);
     p1.add(toLabel);
     p1.add(toChoice);


     liste = new JList (noms);
     JScrollPane defil = new JScrollPane(liste);

     nomLabel = new JLabel("Selectionnez des noms:");

     p2.add(nomLabel);
     p2.add(defil);

     // ajout des panels
     c.add(p1);
     c.add(p2);


     // enregistrement des gestionnaires d'evenements
     fromChoice.addItemListener(this);
     toChoice.addItemListener(this);
     liste.addListSelectionListener(this);
     show();
  }

  // la seule methode de l'interface ItemListener
  public void itemStateChanged(ItemEvent e) {
    if (e.getSource() == fromChoice)
      System.out.println("Depart de " + e.getItem());
    else
      System.out.println("Arrivee de " + e.getItem());
  }

    //la seule mthode de l'interface ListSelectionListener
    public void valueChanged(ListSelectionEvent e){
	if (!e.getValueIsAdjusting()){
	    System.out.print("ListactionPerformed ");
	    Object[]  itemsSelectionnes = liste.getSelectedValues();
	    for (int i=0; i<itemsSelectionnes.length; i++)
		System.out.print(" " + itemsSelectionnes[i]);
	    System.out.println("");
	}
    }



  public static void main(String [] args) {
    new GuiList(330,250,"Liste et Choix");
  }
}
